* v850-opc.c (v850_operands): Add V850_OPERAND_SIGNED flag
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils time
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet gawk"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet time
87 bash prms"
88
89 # directories to be built in a cross environment only
90 #
91 cross_only="target-libiberty target-libgloss target-newlib"
92
93 ## All tools belong in one of the four categories, and are assigned above
94 ## We assign ${configdirs} this way to remove all embedded newlines. This
95 ## is important because configure will choke if they ever get through.
96 ## ${configdirs} is directories we build using the host tools.
97 ## ${target_configdirs} is directories we build using the target tools.
98 #
99 configdirs=`echo ${host_libs} ${host_tools}`
100 target_configdirs=`echo ${target_libs} ${target_tools}`
101
102 ################################################################################
103
104 srctrigger=move-if-change
105 srcname="gnu development package"
106
107 # This gets set non-empty for some net releases of packages.
108 appdirs=""
109
110 # per-host:
111
112 # Work in distributions that contain no compiler tools, like Autoconf.
113 if [ -d ${srcdir}/config ]; then
114 case "${host}" in
115 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
116 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
117 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
118 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
119 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
120 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
121 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
122 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
123 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
124 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
125 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
126 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
127 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
128 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
129 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
130 i[3456]86-*-dgux*) host_makefile_frag=config/mh-sysv4 ;;
131 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
132 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
133 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
134 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
135 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
136 i[3456]86-*-linux*) host_makefile_frag=config/mh-linux ;;
137 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
138 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
139 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
140 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
141 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
142 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
143 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
144 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
145 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
146 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
147 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
148 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
149 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
150 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
151 esac
152 fi
153
154 # If we aren't going to be using gcc, see if we can extract a definition
155 # of CC from the fragment.
156 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
157 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
158 found=
159 for dir in $PATH; do
160 test -z "$dir" && dir=.
161 if test -f $dir/gcc; then
162 found=yes
163 break
164 fi
165 done
166 IFS="$save_ifs"
167 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
168 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
169 if [ -n "${xx}" ] ; then
170 CC=$xx
171 fi
172 fi
173 fi
174
175 # We default to --with-shared on platforms where -fpic is meaningless.
176 # Well, we don't yet, but we will.
177 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
178 case "${target}" in
179 alpha-dec-osf*) enable_shared=yes ;;
180 alpha-*-linux*) enable_shared=yes ;;
181 mips-sgi-irix5*) enable_shared=yes ;;
182 *) enable_shared=no ;;
183 esac
184 fi
185
186 case "${enable_shared}" in
187 yes) shared=yes ;;
188 no) shared=no ;;
189 "") shared=no ;;
190 *) shared=yes ;;
191 esac
192
193 if [ x${shared} = xyes ]; then
194 waugh=
195 case "${host}" in
196 hppa*) waugh=config/mh-papic ;;
197 i[3456]86-*) waugh=config/mh-x86pic ;;
198 sparc64-*) waugh=config/mh-sparcpic ;;
199 *) waugh=config/mh-${host_cpu}pic ;;
200 esac
201 if [ -f ${srcdir}/${waugh} ]; then
202 if [ -n "${host_makefile_frag}" ] ; then
203 cat ${srcdir}/${host_makefile_frag} > mh-frag
204 cat ${srcdir}/${waugh} >> mh-frag
205 host_makefile_frag=mh-frag
206 else
207 host_makefile_frag=${waugh}
208 fi
209 fi
210 fi
211
212 # per-target:
213
214 case "${target}" in
215 v810*) target_makefile_frag=config/mt-v810 ;;
216 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
217 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
218 powerpc*-*-eabi* | \
219 powerpc*-*-elf* | \
220 powerpc*-*-linux* | \
221 powerpc*-*-rtem* | \
222 powerpc*-*-sysv* | \
223 powerpc*-*-solaris*) target_makefile_frag=config/mt-ppc ;;
224 esac
225
226 skipdirs=
227 gasdir=gas
228 use_gnu_ld=
229 use_gnu_as=
230
231 # some tools are so dependent upon X11 that if we're not building with X,
232 # it's not even worth trying to configure, much less build, that tool.
233
234 case ${with_x} in
235 yes | "") # the default value for this tree is that X11 is available
236 ;;
237 no)
238 skipdirs="${skipdirs} tk gash"
239 ;;
240 *)
241 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
242 ;;
243 esac
244
245 # Some tools are only suitable for building in a "native" situation.
246 # Those are added when we have a host==target configuration. For cross
247 # toolchains, we add some directories that should only be useful in a
248 # cross-compiler.
249
250 is_cross_compiler=
251
252 if [ x"${host}" = x"${target}" ] ; then
253 # when doing a native toolchain, don't build the targets
254 # that are in the 'cross only' list
255 skipdirs="${skipdirs} ${cross_only}"
256 is_cross_compiler=no
257 target_subdir=.
258 else
259 # similarly, don't build the targets in the 'native only'
260 # list when building a cross compiler
261 skipdirs="${skipdirs} ${native_only}"
262 is_cross_compiler=yes
263 target_subdir=${target_alias}
264 if [ ! -d ${target_subdir} ] ; then
265 if mkdir ${target_subdir} ; then true
266 else
267 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
268 exit 1
269 fi
270 fi
271 fi
272
273 copy_dirs=
274
275 # Handle --with-headers=XXX. The contents of the named directory are
276 # copied to $(tooldir)/sys-include.
277 if [ x"${with_headers}" != x ]; then
278 if [ x${is_cross_compiler} = xno ]; then
279 echo 1>&2 '***' --with-headers is only supported when cross compiling
280 exit 1
281 fi
282 case "${exec_prefixoption}" in
283 "") x=${prefix} ;;
284 *) x=${exec_prefix} ;;
285 esac
286 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
287 fi
288
289 # Handle --with-libs=XXX. Multiple directories are permitted. The
290 # contents are copied to $(tooldir)/lib.
291 if [ x"${with_libs}" != x ]; then
292 if [ x${is_cross_compiler} = xno ]; then
293 echo 1>&2 '***' --with-libs is only supported when cross compiling
294 exit 1
295 fi
296 # Copy the libraries in reverse order, so that files in the first named
297 # library override files in subsequent libraries.
298 case "${exec_prefixoption}" in
299 "") x=${prefix} ;;
300 *) x=${exec_prefix} ;;
301 esac
302 for l in ${with_libs}; do
303 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
304 done
305 fi
306
307 # If both --with-headers and --with-libs are specified, default to
308 # --without-newlib.
309 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
310 if [ x"${with_newlib}" = x ]; then
311 with_newlib=no
312 fi
313 fi
314
315 # Recognize --with-newlib/--without-newlib.
316 if [ x${with_newlib} = xno ]; then
317 skipdirs="${skipdirs} target-newlib"
318 elif [ x${with_newlib} = xyes ]; then
319 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
320 fi
321
322 # Default to using --with-stabs for certain targets.
323 if [ x${with_stabs} = x ]; then
324 case "${target}" in
325 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
326 with_stabs=yes;
327 withoptions="${withoptions} --with-stabs"
328 ;;
329 esac
330 fi
331
332 # Handle ${copy_dirs}
333 set fnord ${copy_dirs}
334 shift
335 while [ $# != 0 ]; do
336 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
337 :
338 else
339 echo Copying $1 to $2
340
341 # Use the install script to create the directory and all required
342 # parent directories.
343 if [ -d $2 ]; then
344 :
345 else
346 echo >config.temp
347 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
348 fi
349
350 # Copy the directory, assuming we have tar.
351 # FIXME: Should we use B in the second tar? Not all systems support it.
352 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
353
354 # It is the responsibility of the user to correctly adjust all
355 # symlinks. If somebody can figure out how to handle them correctly
356 # here, feel free to add the code.
357
358 echo $1 > $2/COPIED
359 fi
360 shift; shift
361 done
362
363 # Configure extra directories which are host specific
364
365 case "${host}" in
366 i[3456]86-*-go32*)
367 configdirs="$configdirs dosrel" ;;
368 *-cygwin32*)
369 configdirs="$configdirs dosrel" ;;
370 esac
371
372 # Remove more programs from consideration, based on the host or
373 # target this usually means that a port of the program doesn't
374 # exist yet.
375
376 noconfigdirs=""
377
378 case "${host}" in
379 i[3456]86-*-vsta)
380 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
381 ;;
382 i[3456]86-*-go32)
383 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
384 ;;
385 *-*-cygwin32)
386 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
387 ;;
388 ppc*-*-pe)
389 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
390 ;;
391 esac
392
393
394 case "${target}" in
395 *-*-netware)
396 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
397 ;;
398 *-*-vxworks*)
399 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
400 ;;
401 alpha-dec-osf*)
402 # ld works, but does not support shared libraries. emacs doesn't
403 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
404 # gas doesn't generate exception information.
405 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
406 ;;
407 alpha*-*-*vms*)
408 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
409 ;;
410 alpha*-*-*)
411 # newlib is not 64 bit ready
412 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
413 ;;
414 # start-sanitize-arc
415 arc-*-*)
416 noconfigdirs="$noconfigdirs target-libgloss"
417 ;;
418 # end-sanitize-arc
419 arm-*-pe*)
420 noconfigdirs="$noconfigdirs target-libgloss"
421 ;;
422 arm-*-riscix*)
423 noconfigdirs="$noconfigdirs ld target-libgloss"
424 ;;
425 # start-sanitize-d10v
426 d10v-*-*)
427 noconfigdirs="$noconfigdirs target-libgloss"
428 ;;
429 # end-sanitize-d10v
430 h8300*-*-* | \
431 h8500-*-*)
432 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
433 ;;
434 hppa*-*-*elf* | \
435 hppa*-*-lites*)
436 # Do configure ld/binutils/gas for this case.
437 ;;
438 hppa*-*-*)
439 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
440 # cc is gcc, and on any system a user should be able to link cc to
441 # whatever they want. FIXME, emacs emacs19).
442 case "${CC}" in
443 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
444 *) ;;
445 esac
446 noconfigdirs="$noconfigdirs ld shellutils"
447 ;;
448 i[3456]86-*-go32)
449 # but don't build gdb
450 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
451 ;;
452 *-*-cygwin32)
453 target_configdirs="$target_configdirs target-winsup"
454 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
455 # always build newlib.
456 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
457
458 # Can't build gdb for cygwin32 if not native.
459 case "${host}" in
460 *-*-cygwin32) ;; # keep gdb
461 *) noconfigdirs="$noconfigdirs gdb"
462 esac
463 ;;
464 i[3456]86-*-pe)
465 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
466 ;;
467 i[3456]86-*-sco3.2v5*)
468 # The linker does not yet know about weak symbols in COFF,
469 # and is not configured to handle mixed ELF and COFF.
470 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
471 ;;
472 i[3456]86-*-sco*)
473 noconfigdirs="$noconfigdirs gprof target-libgloss"
474 ;;
475 i[3456]86-*-solaris2*)
476 # The linker does static linking correctly, but the Solaris C library
477 # has bugs such that some important functions won't work when statically
478 # linked. (See man pages for getpwuid, for example.)
479 noconfigdirs="$noconfigdirs ld target-libgloss"
480 ;;
481 i[3456]86-*-sysv4*)
482 # The SYSV4 C compiler doesn't handle Emacs correctly
483 case "${CC}" in
484 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
485 *) ;;
486 esac
487 # but that's okay since emacs doesn't work anyway
488 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
489 ;;
490 powerpc-*-aix*)
491 # copied from rs6000-*-* entry
492 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
493 # This is needed until gcc and ld are fixed to work together.
494 use_gnu_ld=no
495 ;;
496 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
497 target_configdirs="$target_configdirs target-winsup"
498 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
499 # always build newlib.
500 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
501 ;;
502 # This is temporary until we can link against shared libraries
503 powerpcle-*-solaris*)
504 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
505 ;;
506 rs6000-*-lynxos*)
507 # The CVS server code doesn't work on the RS/6000
508 # Newlib makes problems for libg++ in crosses.
509 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
510 ;;
511 rs6000-*-aix*)
512 noconfigdirs="$noconfigdirs gprof"
513 # This is needed until gcc and ld are fixed to work together.
514 use_gnu_ld=no
515 ;;
516 rs6000-*-*)
517 noconfigdirs="$noconfigdirs gprof"
518 ;;
519 m68k-apollo-*)
520 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
521 ;;
522 mips*-*-irix5*)
523 # The GNU linker does not support shared libraries.
524 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
525 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
526 ;;
527 mips*-*-irix6*)
528 # The GNU linker does not support shared libraries.
529 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
530 # BFD does not have Irix 6 support yet.
531 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
532 ;;
533 mips*-dec-bsd*)
534 noconfigdirs="$noconfigdirs gprof target-libgloss"
535 ;;
536 mips*-*-bsd*)
537 noconfigdirs="$noconfigdirs gprof target-libgloss"
538 ;;
539 mips*-*-*)
540 noconfigdirs="$noconfigdirs gprof"
541 ;;
542 romp-*-*)
543 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
544 ;;
545 sh-*-*)
546 case "${host}" in
547 i[3456]86-*-vsta) ;; # don't add gprof back in
548 i[3456]86-*-go32) ;; # don't add gprof back in
549 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
550 esac
551 noconfigdirs="$noconfigdirs target-libgloss"
552 ;;
553 sparc-*-sunos4*)
554 if [ x${is_cross_compiler} != xno ] ; then
555 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
556 else
557 use_gnu_ld=no
558 fi
559 ;;
560 v810-*-*)
561 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
562 ;;
563 # start-sanitize-v850
564 v850-*-*)
565 noconfigdirs="$noconfigdirs gdb target-libgloss"
566 ;;
567 # end-sanitize-v850
568 vax-*-vms)
569 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
570 ;;
571 vax-*-*)
572 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
573 ;;
574 *-*-lynxos*)
575 # Newlib makes problems for libg++ in crosses.
576 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
577 ;;
578 *-*-macos* | \
579 *-*-mpw*)
580 # Macs want a resource compiler.
581 configdirs="$configdirs grez"
582 ;;
583 esac
584
585 # targets that need a second pass
586 case "${target}" in
587 *-gm-magic*)
588 noconfigdirs="$noconfigdirs target-libgloss"
589 ;;
590 esac
591
592 # If we aren't building newlib, then don't build libgloss, since libgloss
593 # depends upon some newlib header files.
594 case "${noconfigdirs}" in
595 *target-libgloss*) ;;
596 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
597 esac
598
599 # If we are building a Canadian Cross, discard tools that can not be built
600 # using a cross compiler. FIXME: These tools should be fixed.
601 if [ "${build}" != "${host}" ]; then
602 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
603 fi
604
605 # Make sure we don't let GNU ld be added if we didn't want it.
606 if [ x$with_gnu_ld = xno ]; then
607 use_gnu_ld=no
608 noconfigdirs="$noconfigdirs ld"
609 fi
610
611 # Make sure we don't let GNU as be added if we didn't want it.
612 if [ x$with_gnu_as = xno ]; then
613 use_gnu_as=no
614 noconfigdirs="$noconfigdirs gas"
615 fi
616
617 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
618 # $target_configdirs.
619 # If we have the source for $noconfigdirs entries, add them to $notsupp.
620
621 notsupp=""
622 for dir in . $skipdirs $noconfigdirs ; do
623 dirname=`echo $dir | sed -e s/target-//g`
624 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
625 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
626 if [ -r $srcdir/$dirname/configure ] \
627 || [ -r $srcdir/$dirname/configure.in ]; then
628 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
629 true
630 else
631 notsupp="$notsupp $dir"
632 fi
633 fi
634 fi
635 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
636 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
637 if [ -r $srcdir/$dirname/configure ] \
638 || [ -r $srcdir/$dirname/configure.in ]; then
639 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
640 true
641 else
642 notsupp="$notsupp $dir"
643 fi
644 fi
645 fi
646 done
647
648 # Sometimes the tools are distributed with libiberty but with no other
649 # libraries. In that case, we don't want to build target-libiberty.
650 if [ -n "${target_configdirs}" ]; then
651 others=
652 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
653 if [ "$i" != "libiberty" ]; then
654 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
655 others=yes;
656 break;
657 fi
658 fi
659 done
660 if [ -z "${others}" ]; then
661 target_configdirs=
662 fi
663 fi
664
665 # Deconfigure all subdirectories, in case we are changing the
666 # configuration from one where a subdirectory is supported to one where it
667 # is not.
668 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
669 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
670 rm -f $i/Makefile
671 done
672 fi
673 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
674 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
675 rm -f ${target_subdir}/$i/Makefile
676 done
677 fi
678
679 # Produce a warning message for the subdirs we can't configure.
680 # This isn't especially interesting in the Cygnus tree, but in the individual
681 # FSF releases, it's important to let people know when their machine isn't
682 # supported by the one or two programs in a package.
683
684 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
685 # If $appdirs is non-empty, at least one of those directories must still
686 # be configured, or we error out. (E.g., if the gas release supports a
687 # specified target in some subdirs but not the gas subdir, we shouldn't
688 # pretend that all is well.)
689 if [ -n "$appdirs" ]; then
690 for dir in $appdirs ; do
691 if [ -r $dir/Makefile.in ]; then
692 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
693 appdirs=""
694 break
695 fi
696 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
697 appdirs=""
698 break
699 fi
700 fi
701 done
702 if [ -n "$appdirs" ]; then
703 echo "*** This configuration is not supported by this package." 1>&2
704 exit 1
705 fi
706 fi
707 # Okay, some application will build, or we don't care to check. Still
708 # notify of subdirs not getting built.
709 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
710 echo " ${notsupp}" 1>&2
711 echo " (Any other directories should still work fine.)" 1>&2
712 fi
713
714 # Set with_gnu_as and with_gnu_ld as appropriate.
715 #
716 # This is done by determining whether or not the appropriate directory
717 # is available, and by checking whether or not specific configurations
718 # have requested that this magic not happen.
719 #
720 # The command line options always override the explicit settings in
721 # configure.in, and the settings in configure.in override this magic.
722 #
723 # If the default for a toolchain is to use GNU as and ld, and you don't
724 # want to do that, then you should use the --without-gnu-as and
725 # --without-gnu-ld options for the configure script.
726
727 if [ x${use_gnu_as} = x ] ; then
728 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
729 with_gnu_as=yes
730 withoptions="$withoptions --with-gnu-as"
731 fi
732 fi
733
734 if [ x${use_gnu_ld} = x ] ; then
735 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
736 with_gnu_ld=yes
737 withoptions="$withoptions --with-gnu-ld"
738 fi
739 fi
740
741 if [ x${shared} = xyes ]; then
742 case "${target}" in
743 hppa*) target_makefile_frag=config/mt-papic ;;
744 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
745 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
746 esac
747 fi
748
749 # post-target:
750
751 # Make sure that the compiler is able to generate an executable. If it
752 # can't, we are probably in trouble. We don't care whether we can run the
753 # executable--we might be using a cross compiler--we only care whether it
754 # can be created. At this point the main configure script has set CC.
755 echo "int main () { return 0; }" > conftest.c
756 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
757 if [ $? = 0 ] && [ -s conftest ]; then
758 :
759 else
760 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
761 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
762 rm -f conftest*
763 exit 1
764 fi
765 rm -f conftest*
766
767 # The Solaris /usr/ucb/cc compiler does not appear to work.
768 case "${host}" in
769 sparc-sun-solaris2*)
770 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
771 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
772 could_use=
773 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
774 if [ -d /opt/cygnus/bin ] ; then
775 if [ "$could_use" = "" ] ; then
776 could_use="/opt/cygnus/bin"
777 else
778 could_use="$could_use or /opt/cygnus/bin"
779 fi
780 fi
781 if [ "$could_use" = "" ] ; then
782 echo "Warning: compilation may fail because you're using"
783 echo "/usr/ucb/cc. You should change your PATH or CC "
784 echo "variable and rerun configure."
785 else
786 echo "Warning: compilation may fail because you're using"
787 echo "/usr/ucb/cc, when you should use the C compiler from"
788 echo "$could_use. You should change your"
789 echo "PATH or CC variable and rerun configure."
790 fi
791 fi
792 ;;
793 esac
794
795 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
796 # binutils tools will find libbfd.so.
797 if [ "${shared}" = "yes" ]; then
798 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
799 Makefile > Makefile.tem
800 rm -f Makefile
801 mv -f Makefile.tem Makefile
802
803 case "${host}" in
804 *-*-hpux*)
805 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
806 Makefile > Makefile.tem
807 rm -f Makefile
808 mv -f Makefile.tem Makefile
809 ;;
810 esac
811 fi
812
813 # Record target_configdirs and the configure arguments in Makefile.
814 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
815 targargs=`echo "${arguments}" | \
816 sed -e 's/--norecursion//' \
817 -e 's/--cache[a-z-]*=[^ ]*//' \
818 -e 's/--ho[a-z-]*=[^ ]*//' \
819 -e 's/--ta[a-z-]*=[^ ]*//'`
820
821 # Passing a --with-cross-host argument lets the target libraries know
822 # whether they are being built with a cross-compiler or being built
823 # native. However, it would be better to use other mechanisms to make the
824 # sorts of decisions they want to make on this basis. Please consider
825 # this option to be deprecated. FIXME.
826 if [ x${is_cross_compiler} = xyes ]; then
827 targargs="--with-cross-host=${host_alias} ${targargs}"
828 fi
829
830 targargs="--host=${target_alias} ${targargs}"
831 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
832 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
833 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
834 Makefile > Makefile.tem
835 rm -f Makefile
836 mv -f Makefile.tem Makefile
837
838 #
839 # Local Variables:
840 # fill-column: 131
841 # End:
842 #
This page took 0.050362 seconds and 4 git commands to generate.